SPEC ISLIST =

FORMAL 
  
  SORTS index. data.
  OPNS  compare :: index -> index -> boolean.

GLOBAL
  SLIST ACTUAL SORTS data=index. list=indices. OPNS compare=compare. END+
  LIST  ACTUAL SORTS data=data.  list=datas.   END+
  
  SORTS list ::= ilist(indices::indices,datas::datas).

  OPNS mt :: list.
       ismt :: list -> boolean.
       
       insert :: (index,data,list) -> list.
       del :: (index,list) -> list.
       get :: (index,data,list) -> (boolean,data).
       
       member :: list -> index -> boolean.
       
       hd :: list -> index.
       hd :: list -> data.
       
       tl :: list -> list.
       
LOCAL

EQNS
  [] = ilist(mt,[]).
  
  ismt (ilist(IS,DS)) = (IS==mt) && (DS==[]).

MACROS
  #ins_i = IDX : IS.
  #I     = idx #ins_i IDX.
  #ITH   = idx IS IDX.
  
EQNS 
  insert(IDX,D,ilist(IS,DS)) = 
    if member IS IDX 
    then ilist(IS,insert_behind_ith(#ITH,D,delete_ith(#ITH,DS)))
    else ilist(#ins_i,insert_behind_ith(#I-1,D,DS)).

  del(IDX,ilist(IS,DS)) = 
    if member IS IDX
    then ilist(delete_ith(#ITH,IS),delete_ith(#ITH,DS))
    else ilist(IS,DS).
  
  member (ilist(IS,_)) = member IS.
  
  hd(ilist(IS,_)) = hd IS.
  hd(ilist(_,DS)) = hd DS.
  
  tl(ilist(IS,DS)) = ilist(tl IS,tl DS).

  get(IDX,ERR,ilist(IS,DS)) = 
    (member IS IDX,
     if member IS IDX then DS!(idx IS IDX) else ERR).

END.
