SPEC POSITION =

SORTS pos ::= mkPos( lin :: integer, col :: integer ).


OPNS firstPos,
     emptyPos :: pos.

     nextCol,
     nextLin  :: pos -> pos.
     
     nextPos  :: (pos,char) -> pos.
     
     pos >  pos ,
     pos <  pos ,
     pos >= pos ,
     pos <= pos ,
     pos |= pos :: boolean.


LOCAL INTEGER + BOOLEAN + UNIX +

EQNS  firstPos	= mkPos (1,1).
      emptyPos	= mkPos (0,0).
      
      nextCol(mkPos(L,C)) = mkPos(L,  C+1).
      nextLin(mkPos(L,C)) = mkPos(L+1,C  ).
      
      nextPos(mkPos(L,C),Ch) =
        if Ch == tabCh
        then mkPos(L,if C _mod htabWidth == 0
                     then C
                     else (C+htabWidth)-(C _mod htabWidth))
        elsif Ch == newLineCh
        then mkPos(L+1,C)
        else mkPos(L,C+1).
      
      mkPos(L1,C1) > mkPos(L2,C2) =
        if L1>L2 then true elsif L1<L2 then false else C1>C2.

FORALL P1,P2 :: pos.
EQNS         
      P1 <  P2 = P2 >  P1.
      P1 >= P2 = not (P2 >  P1).
      P1 <= P2 = not (P1 >  P2).
      P1 |= P2 = not (P1 == P2).
      
END.
