SPEC MASTERMIND = INTEGER_UTIL + STREAM + LISTOPS +

SORTS is ::= [integer].
      iss ::= [is].
      
SORTS info ::= [integer].
OPNS add::(integer,integer) -> info -> info.
EQNS 
  add XI [] = add XI [0].  
  add (X,I) [N|NN] =
    if I == 0
    then if X == 0
         then [N+1|NN]
         else [N|add (X-1,4 - (X-1)) NN]
    else [N|add (X,I-1) NN].
    
OPNS compare_all::iss -> iss -> integer -> (integer,is) -> is.
MACROS #D = deriv MEAN (split X ALL []).
EQNS
  compare_all [] _ _ (_,BEST) = BEST.
  compare_all [X|XX] ALL MEAN (D,BEST) =
    compare_all XX ALL MEAN (if #D < D then (#D,X) else (D,BEST)). 
    
OPNS deriv::integer -> info -> integer.
MACROS #d = MEAN - X.
EQNS
  deriv _ [] = 0.
  deriv MEAN [X|XX] = (#d * #d) + deriv MEAN XX.

OPNS split :: is -> iss -> info -> info.
MACROS (#X,#a,#b) = place X Y.
       #I = inthere #a #b.
EQNS split _ [] I = I.
     split X (Y:YY) I = split X YY (if #X == 4 then I else (add(#X,#I) I)).

OPNS   place :: is -> is -> (integer,is,is).
MACROS (#i,#x,#y) = place X Y.
EQNS   place (A:X) (B:Y) = if A==B then (#i+1,  #x,  #y)
                                   else (#i  ,A:#x,B:#y).
      $place _ _ = (0,[],[]).

OPNS   inthere :: is -> is -> integer.
MACROS (#i,#y) = inthere A Y.
EQNS   inthere (A:X) Y = #i+inthere X #y.
       inthere [] _ = 0.

OPNS   inthere :: integer -> is -> (integer,is).
MACROS (#i,#x) = inthere I X.
EQNS   inthere _ [] = (0,[]).
       inthere I (A:X) = if I==A then (1,X)
                                 else (#i,A:#x). 

OPNS   gen :: integer -> integer -> integer -> integer -> iss.
EQNS   gen A B C D = [[A,B,C,D]
                     | if D==6
                       then if C==6
                            then if B==6
                                 then if A==6
                                      then []
                                      else gen (A+1) 1 1 1
                                 else gen A (B+1) 1 1
                            else gen A B (C+1) 1
                       else gen A B C (D+1)
                      ].

OPNS filter :: is -> iss -> integer -> integer -> iss.
EQNS filter _ [] _ _ = [].
     filter C (A:X) R P = if test C A R P then A:filter C X R P 
                                          else   filter C X R P.

OPNS   test :: is -> is -> integer -> integer -> boolean.
MACROS (#r,#x,#y) = place X Y.
EQNS   test X Y R I = if #r == R then inthere #x #y == I else false.

OPNS test_all::integer -> integer -> iss -> system -> system.
MACROS #REST = filter [1,1,2,3] ALL X O.
       #OUT = system(write(
               compare_all #REST #REST (length #REST _div 13) (maxint,[]),S)) + 
              "(" + integer_string(X) + "," + integer_string(O) + ")\n".
EQNS
  test_all X O ALL S =
    if O == 0
    then if X == 0
         then #OUT
         else test_all (X-1) (4 - (X-1)) ALL #OUT
    else test_all X (O-1) ALL #OUT.
  
OPNS goal :: system -> system.
MACROS #ALL = gen 1 1 1 1.
EQNS 
  goal S = test_all 3 0 #ALL S.

END.
